@echo off

set CommonCompilerOptions=/Zi /FC /nologo /DW32_LINK_SINGLE=1 /DVN_INTERNAL=0 /DVN_SLOW=0 /DVN_USE_INSTANCING=1 /O2 /W4 /WX /we4062 /wd4996 /wd4201 /wd4305 /wd4244 /wd4100 /wd4505 /std:c++17

if not exist "../release" mkdir "../release"

pushd "../release/"
rem cl /Zi /nologo /FC ../code/third_party/codegen/codegen.c
"../build/codegen" ../code/

cl %CommonCompilerOptions% ../code/win32_main.cpp /link user32.lib gdi32.lib winmm.lib opengl32.lib

xcopy /y /q win32_main.exe vn.exe
del win32_main.*
del *.pdb
popd