@table(Name, Path, IsPermanent, Scale) assets_desc:
{
	{ None,                      "",                                      true,     0      }
	{ Error,                     "backgrounds/unknown.png",               true,     0      }
	
	////////////////////////////////
	//~ sixten: backgrounds
	{ DemoBackground,            "backgrounds/test.jpg",                  false,    1      }
	{ DDLCBackground,            "backgrounds/ddlc.png",                  false,    1      }
	
	////////////////////////////////
	//~ sixten: characters
	
	//- sixten: arthur
	{ ArthurNormal,              "characters/test_normal.png",            false,    0.017  }
	{ ArthurHappy,               "characters/test_happy.png",             false,    0.017  }
	
	//- sixten: monika
	{ MonikaLeaning,             "characters/monika_leaning.png",         false,    0.033  }
	
	////////////////////////////////
	//~ sixten: puzzles
	
	{ Duck,                      "puzzles/duck.png",                      false,    1      }
	
}


@table_gen
{
	`typedef s32 asset_id;`
		`enum`
		`{`
			@expand(assets_desc s) `AssetID_$(s.Name),`;
		`AssetID_COUNT,`;
		`};`
}

@table_gen_data(`char *`) AssetPathLUT:
{
	@expand(assets_desc s)
		`"$(s.Path)",`;
}

@table_gen_data(`bool`) AssetIsPermanentLUT:
{
	@expand(assets_desc s)
		`$(s.IsPermanent),`;
}

@table_gen_data(`char *`) AssetNameLUT:
{
	@expand(assets_desc s)
		`"$(s.Name)",`;
}
@table_gen_data(`r32`) AssetScaleLUT:
{
	@expand(assets_desc s)
		`$(s.Scale),`;
}