#ifndef VN_WORKSPACE_FILE_LISTER_H
#define VN_WORKSPACE_FILE_LISTER_H

struct workspace_file_lister_action
{
	b32 HasRequestedFile;
	string Path;
	string Name;
};

struct workspace_view_file_lister
{
	string Path;
	r32 Scroll;
	u8 Input[256];
	s64 InputUsed;
	text_edit_state InputEditState;
	s32 SelectedItem;
};

static workspace_file_lister_action *W_FileListerActionCopy(arena *Arena, workspace_file_lister_action *Action);

static b32 W_BuildFileListerItem(string Text, u32 Icon, b32 Selected, b32 EnterPressed);
static workspace_file_lister_action W_BuildFileLister(workspace_view *View);

#endif //VN_WORKSPACE_FILE_LISTER_H
